osg::Vec4f Class Reference

`#include <Vec4f>`

## Public Types

enum | { num_components = 4 }
typedef float | value_type

## Public Member Functions

| Vec4f ()
| Vec4f (value_type x, value_type y, value_type z, value_type w)
| Vec4f (const Vec3f &v3, value_type w)
bool | operator== (const Vec4f &v) const
bool | operator!= (const Vec4f &v) const
bool | operator< (const Vec4f &v) const
value_type * | ptr ()
const value_type * | ptr () const
void | set (value_type x, value_type y, value_type z, value_type w)
value_type & | operator[] (unsigned int i)
value_type | operator[] (unsigned int i) const
value_type & | x ()
value_type & | y ()
value_type & | z ()
value_type & | w ()
value_type | x () const
value_type | y () const
value_type | z () const
value_type | w () const
value_type & | r ()
value_type & | g ()
value_type & | b ()
value_type & | a ()
value_type | r () const
value_type | g () const
value_type | b () const
value_type | a () const
unsigned int | asABGR () const
unsigned int | asRGBA () const
bool | valid () const
bool | isNaN () const
value_type | operator* (const Vec4f &rhs) const
Vec4f | operator* (value_type rhs) const
Vec4f & | operator*= (value_type rhs)
Vec4f | operator/ (value_type rhs) const
Vec4f & | operator/= (value_type rhs)
Vec4f | operator+ (const Vec4f &rhs) const
Vec4f & | operator+= (const Vec4f &rhs)
Vec4f | operator- (const Vec4f &rhs) const
Vec4f & | operator-= (const Vec4f &rhs)
const Vec4f | operator- () const
value_type | length () const
value_type | length2 () const
value_type | normalize ()

## Public Attributes

value_type | _v [4]

## Detailed Description

General purpose float quad. Uses include representation of color coordinates. No support yet added for float * Vec4f - is it necessary? Need to define a non-member non-friend operator* etc. Vec4f * float is okay

## Member Typedef Documentation

## value_type

typedef float osg::Vec4f::value_type

Data type of vector components.

## Member Enumeration Documentation

## anonymous enum

anonymous enum

Number of vector components.

Enumerator
num_components |

## Constructor & Destructor Documentation

## Vec4f() [1/3]

osg::Vec4f::Vec4f | ( |  | ) |

inline

Constructor that sets all components of the vector to zero

References _v.

Referenced by operator!=(), operator*(), operator*(), operator*=(), operator+(), operator+=(), operator-(), operator-(), operator-=(), operator/(), operator/=(), operator<(), and operator==().

## Vec4f() [2/3]

osg::Vec4f::Vec4f | ( | value_type | x,
|  | value_type | y,
|  | value_type | z,
|  | value_type | w )

inline

References _v, w(), x(), y(), and z().

## Vec4f() [3/3]

osg::Vec4f::Vec4f | ( | const Vec3f & | v3,
|  | value_type | w )

inline

References _v, and w().

## Member Function Documentation

## a() [1/2]

value_type & osg::Vec4f::a | ( |  | ) |

inline

References _v.

Referenced by osg::convertToRGBA8().

## a() [2/2]

value_type osg::Vec4f::a | ( |  | ) | const

inline

References _v.

## asABGR()

unsigned int osg::Vec4f::asABGR | ( |  | ) | const

inline

References _v, and osg::clampTo().

## asRGBA()

unsigned int osg::Vec4f::asRGBA | ( |  | ) | const

inline

References _v, and osg::clampTo().

## b() [1/2]

value_type & osg::Vec4f::b | ( |  | ) |

inline

References _v.

Referenced by osg::convertToRGBA8().

## b() [2/2]

value_type osg::Vec4f::b | ( |  | ) | const

inline

References _v.

## g() [1/2]

value_type & osg::Vec4f::g | ( |  | ) |

inline

References _v.

Referenced by osg::convertToRGBA8().

## g() [2/2]

value_type osg::Vec4f::g | ( |  | ) | const

inline

References _v.

## isNaN()

bool osg::Vec4f::isNaN | ( |  | ) | const

inline

Returns true if at least one component has value NaN.

References _v, and osg::isNaN().

Referenced by valid().

## length()

value_type osg::Vec4f::length | ( |  | ) | const

inline

Length of the vector = sqrt( vec . vec )

References _v.

Referenced by normalize().

## length2()

value_type osg::Vec4f::length2 | ( |  | ) | const

inline

Length squared of the vector = vec . vec

References _v.

## normalize()

value_type osg::Vec4f::normalize | ( |  | ) |

inline

Normalize the vector so that it has length unity. Returns the previous length of the vector.

References _v, and length().

## operator!=()

bool osg::Vec4f::operator!= | ( | const Vec4f & | v | ) | const

inline

References _v, and Vec4f().

## operator*() [1/2]

value_type osg::Vec4f::operator* | ( | const Vec4f & | rhs | ) | const

inline

Dot product.

References _v, and Vec4f().

## operator*() [2/2]

Vec4f osg::Vec4f::operator* | ( | value_type | rhs | ) | const

inline

Multiply by scalar.

References _v, and Vec4f().

## operator*=()

Vec4f & osg::Vec4f::operator*= | ( | value_type | rhs | ) |

inline

Unary multiply by scalar.

References _v, and Vec4f().

## operator+()

Vec4f osg::Vec4f::operator+ | ( | const Vec4f & | rhs | ) | const

inline

Binary vector add.

References _v, and Vec4f().

## operator+=()

Vec4f & osg::Vec4f::operator+= | ( | const Vec4f & | rhs | ) |

inline

Unary vector add. Slightly more efficient because no temporary intermediate object.

References _v, and Vec4f().

## operator-() [1/2]

const Vec4f osg::Vec4f::operator- | ( |  | ) | const

inline

Negation operator. Returns the negative of the Vec4f.

References _v, and Vec4f().

## operator-() [2/2]

Vec4f osg::Vec4f::operator- | ( | const Vec4f & | rhs | ) | const

inline

Binary vector subtract.

References _v, and Vec4f().

## operator-=()

Vec4f & osg::Vec4f::operator-= | ( | const Vec4f & | rhs | ) |

inline

Unary vector subtract.

References _v, and Vec4f().

## operator/()

Vec4f osg::Vec4f::operator/ | ( | value_type | rhs | ) | const

inline

Divide by scalar.

References _v, and Vec4f().

## operator/=()

Vec4f & osg::Vec4f::operator/= | ( | value_type | rhs | ) |

inline

Unary divide by scalar.

References _v, and Vec4f().

## operator<()

bool osg::Vec4f::operator< | ( | const Vec4f & | v | ) | const

inline

References _v, and Vec4f().

## operator==()

bool osg::Vec4f::operator== | ( | const Vec4f & | v | ) | const

inline

References _v, and Vec4f().

## operator[]() [1/2]

value_type & osg::Vec4f::operator[] | ( | unsigned int | i | ) |

inline

References _v.

## operator[]() [2/2]

value_type osg::Vec4f::operator[] | ( | unsigned int | i | ) | const

inline

References _v.

## ptr() [1/2]

value_type * osg::Vec4f::ptr | ( |  | ) |

inline

References _v.

## ptr() [2/2]

const value_type * osg::Vec4f::ptr | ( |  | ) | const

inline

References _v.

## r() [1/2]

value_type & osg::Vec4f::r | ( |  | ) |

inline

References _v.

Referenced by osg::convertToRGBA8().

## r() [2/2]

value_type osg::Vec4f::r | ( |  | ) | const

inline

References _v.

## set()

void osg::Vec4f::set | ( | value_type | x,
|  | value_type | y,
|  | value_type | z,
|  | value_type | w )

inline

References _v, w(), x(), y(), and z().

## valid()

bool osg::Vec4f::valid | ( |  | ) | const

inline

Returns true if all components have values that are not NaN.

References isNaN().

## w() [1/2]

value_type & osg::Vec4f::w | ( |  | ) |

inline

References _v.

Referenced by osgUtil::HighlightMapGenerator::compute_color(), osgParticle::Interpolator::interpolate(), osgTerrain::ValidDataOperator::operator()(), osg::Matrixd::postMult(), osg::Matrixf::postMult(), osg::Matrixd::preMult(), osg::Matrixf::preMult(), osg::Quat::Quat(), osg::Quat::set(), set(), osgUtil::CubeMapGenerator::set_pixel(), Vec4f(), and Vec4f().

## w() [2/2]

value_type osg::Vec4f::w | ( |  | ) | const

inline

References _v.

## x() [1/2]

value_type & osg::Vec4f::x | ( |  | ) |

inline

References _v.

Referenced by osgParticle::Interpolator::interpolate(), osgTerrain::ValidDataOperator::operator()(), osg::Matrixd::postMult(), osg::Matrixf::postMult(), osg::Matrixd::preMult(), osg::Matrixf::preMult(), osg::Quat::Quat(), osg::Quat::set(), set(), osgUtil::CubeMapGenerator::set_pixel(), and Vec4f().

## x() [2/2]

value_type osg::Vec4f::x | ( |  | ) | const

inline

References _v.

## y() [1/2]

value_type & osg::Vec4f::y | ( |  | ) |

inline

References _v.

Referenced by osgParticle::Interpolator::interpolate(), osgTerrain::ValidDataOperator::operator()(), osg::Matrixd::postMult(), osg::Matrixf::postMult(), osg::Matrixd::preMult(), osg::Matrixf::preMult(), osg::Quat::Quat(), osg::Quat::set(), set(), osgUtil::CubeMapGenerator::set_pixel(), and Vec4f().

## y() [2/2]

value_type osg::Vec4f::y | ( |  | ) | const

inline

References _v.

## z() [1/2]

value_type & osg::Vec4f::z | ( |  | ) |

inline

References _v.

Referenced by osgParticle::Interpolator::interpolate(), osgTerrain::ValidDataOperator::operator()(), osg::Matrixd::postMult(), osg::Matrixf::postMult(), osg::Matrixd::preMult(), osg::Matrixf::preMult(), osg::Quat::Quat(), osg::Quat::set(), set(), osgUtil::CubeMapGenerator::set_pixel(), and Vec4f().

## z() [2/2]

value_type osg::Vec4f::z | ( |  | ) | const

inline

References _v.

## Member Data Documentation

## _v

value_type osg::Vec4f::_v[4]

Vec member variable.

Referenced by a(), a(), asABGR(), asRGBA(), b(), b(), g(), g(), isNaN(), length(), length2(), normalize(), operator!=(), operator*(), operator*(), operator*=(), operator+(), operator+=(), operator-(), operator-(), operator-=(), operator/(), operator/=(), operator<(), osg::operator<<(), operator==(), osg::operator>>(), operator[](), operator[](), ptr(), ptr(), r(), r(), set(), osg::Vec4d::Vec4d(), Vec4f(), Vec4f(), Vec4f(), w(), w(), x(), x(), y(), y(), z(), and z().

The documentation for this class was generated from the following file:

- Vec4f